<?php
class AuditTrailTable
{
	var $logTableName="basic_system_audit";
	var $params;

	var $strLogin="login";
	var $strFailLogin="failed login";
	var $strLogout="logout";
	var $strChPass="change password";
	var $strAdd="add";
	var $strEdit="edit";
	var $strDelete="delete";
	var $strAccess="access";
	var $strKeysHeader="---Keys";
	var $strFieldsHeader="---Fields";
	var $strUserinfo="change userinfo";
	var $columnDate="Date";
	var $columnTime="Time";
	var $columnIP="IP";
	var $columnUser="User";
	var $columnTable="Table";
	var $columnAction="Action";
	var $columnKey="Key field";
	var $columnField="Field";
	var $columnOldValue="Old value";
	var $columnNewValue="New value";
	var $attLogin=0;
	var $timeLogin=0;
	var $maxFieldLength;

	/**
	 * @type Connection
	 */
	protected $connection;

	function __construct()
	{
		global $cman;
		global $auditMaxFieldLength;

		$this->connection = $cman->getForAudit();
		$this->attLogin=3;
		$this->timeLogin=5;
		$userid="";
		if( Security::getUserName())
			$userid = Security::getUserName();

		$this->params=array($_SERVER["REMOTE_ADDR"],$userid);

		$this->maxFieldLength = $auditMaxFieldLength;
	}

    function LogLogin($pUsername)
    {
		global $globalEvents;
		$retval=true;
		$table="employees";
		$this->params[1]=$pUsername;
		$arr=array();
		$this->params=array($_SERVER["REMOTE_ADDR"], Security::getUserName() );
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strLogin, $this->params, $table, $arr, $arr, $arr);
		if($retval)
		{
			$this->insert(now(), $this->params[0], $this->params[1], $table, $this->strLogin, "");
		}
		return $retval;
    }

    function LogLoginFailed($pUsername)
    {
		global $globalEvents;
		$retval=true;
		$table="employees";
		$this->params[1]=$pUsername;
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strFailLogin, $this->params, $table, $arr, $arr, $arr);
		if($retval)
		{
			$this->insert(now(), $this->params[0], $this->params[1], $table, $this->strFailLogin, "");
		}
		$this->params=array($_SERVER["REMOTE_ADDR"],"");
		return $retval;
    }

    function LogLogout()
    {
	global $globalEvents;
	if( Security::getUserName() !="" )
	{
		$retval=true;
		$table="employees";
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strLogout, $this->params, $table, $arr, $arr, $arr);
		if($retval)
		{
			$this->insert(now(), $this->params[0], $this->params[1], $table, $this->strLogout, "");
		}
		return $retval;
	}
    }

    function LogChPassword( $username )
    {
		global $globalEvents;
		$retval=true;
		$table="employees";
		$arr=array();
		$this->params[ 1 ] = $username;
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strChPass, $this->params, $table, $arr, $arr, $arr);
		if($retval)
		{
			$this->insert(now(), $this->params[0], $this->params[1], $table, $this->strChPass, "");
		}
		return $retval;
    }

    function LogAdd($str_table,$values,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strAdd, $this->params, $table, $keys, $values, $arr);
		if($retval)
		{
			$str="";
			if(count($keys)>0)
			{
				$str.=$this->strKeysHeader."\r\n";
				foreach($keys as $idx=>$val)
					$str.=$idx." : ".$val."\r\n";
			}
			$strFields="";
			if($this->logValueEnable($str_table))
			{
				foreach($values as $idx=>$val)
				{
					if($val!="" && !array_key_exists($idx,$keys))
					{
						$strFields.=$idx." [new]: ";
						if(IsBinaryType($pSet->getFieldType($idx)))
							$v="<binary value>";
						else
						{
							$v = str_replace(array("\r\n","\n","\t")," ",$val);
							$v = $this->getMaxLengthSubstr( $v );
						}
						$strFields.=$v."\r\n";
					}
				}
			}
			if($strFields!="")
				$str.=$this->strFieldsHeader."\r\n".$strFields;

			$this->insert(now(), $this->params[0], $this->params[1], $str_table, $this->strAdd, $str);
		}
		return $retval;
	}
	
	/**
	* not used yet 
	* format audit values as a string
	 * @param Array $newValues
	 * @param Array $oldValues
	 * @param Array include - list of fields to include into return value
	 * @return String
	 */
	function formatChangedValues( $pSet, $newValues, $oldValues, $include = null ) {
		
		$strings = array();
		foreach($newValues as $kefieldy => $value )
		{
			if( $include ) {
				//	ASP
				if( !isset( $include[ $field ] ) ) {
					continue;
				}
			}

			$type = $pSet->getFieldType( $field );
			if( IsBinaryType($type) )
				continue;
			
			if( IsDateFieldType($type) ) {
				$newValue = format_datetime_custom(db2time( $newValues[$field] ),"yyyy-MM-dd HH:mm:ss");
				$oldValue = format_datetime_custom(db2time( $oldValues[$field] ),"yyyy-MM-dd HH:mm:ss");
			} else {
				$newValue = $newValues[$field];
				$oldValue = $oldValues[$field];
			}
			
			if( $newValue == $oldValue ) {
				continue;
			}
			
			$strOld = $field . " [old]: " . $this->formatValue( $type, $oldValue );
			$strNew = $field . " [new]: " . $this->formatValue( $type, $newValue );
			$string[] = $strOld . "\r\n" . $strNew;

		}
		return implode( "\r\n", $strings );
	}

	function formatValue( $type, $value ) {
		if(IsBinaryType($type)) {
			return "<binary value>"; 
		} else {
			$value = str_replace(array("\r\n","\n","\t")," ", $value );
			return $this->getMaxLengthSubstr( $value );
		}
	}

    function LogEdit($str_table,$newvalues,$oldvalues, $keys )
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strEdit, $this->params, $table, $keys, $newvalues, $oldvalues);
		if($retval)
		{
			$str="";
			if(count($keys)>0)
			{
				$str.=$this->strKeysHeader."\r\n";
				foreach($newvalues as $idx=>$val)
				{
					if(array_key_exists($idx,$keys))
					{
						if($val!=$oldvalues[$idx])
						{
							$str.=$idx." [old]: ".$oldvalues[$idx]."\r\n";
							$str.=$idx." [new]: ".$val."\r\n";
						}
						else
							$str.=$idx." : ".$val."\r\n";
					}
				}
			}
			$strFields="";
			if($this->logValueEnable($str_table))
			{
				$v="";
				foreach($newvalues as $idx=>$val)
				{
					$type=$pSet->getFieldType($idx);
					if(IsBinaryType($type))
						continue;
					if(IsDateFieldType($type))
					{
						$newvalue=format_datetime_custom(db2time($newvalues[$idx]),"yyyy-MM-dd HH:mm:ss");
						$oldvalue=format_datetime_custom(db2time($oldvalues[$idx]),"yyyy-MM-dd HH:mm:ss");
					}
					else
					{
						$newvalue=$newvalues[$idx];
						$oldvalue=$oldvalues[$idx];
					}
					if($newvalue!=$oldvalue && !array_key_exists($idx,$keys))
					{
						$strFields.=$idx." [old]: ";
						if(IsBinaryType($type))
							$v="<binary value>";
						else
						{
							$v = str_replace(array("\r\n","\n","\t")," ",$oldvalue);
							$v = $this->getMaxLengthSubstr( $v );
						}
						$strFields.=$v."\r\n";

						$strFields.=$idx." [new]: ";
						if(IsBinaryType($type))
							$v="<binary value>";
						else
						{
							$v = str_replace(array("\r\n","\n","\t")," ",$newvalue);
							$v = $this->getMaxLengthSubstr( $v );
						}
						$strFields.=$v."\r\n";
					}
				}
				$v="";
			}
			if($strFields!="")
				$str.=$this->strFieldsHeader."\r\n".$strFields;

			$this->insert(now(), $this->params[0], $this->params[1], $str_table, $this->strEdit, $str);
		}
		return $retval;
    }

    function LogDelete($str_table,$values,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strDelete, $this->params, $table, $keys, $values, $arr);
		if($retval)
		{
			$str="";
			if(count($keys)>0)
			{
				$str.=$this->strKeysHeader."\r\n";
				foreach($keys as $idx=>$val)
					$str.=$idx." : ".$val."\r\n";
			}
			$strFields="";
			if($this->logValueEnable($str_table))
			{
				$v="";
				foreach($values as $idx=>$val)
				{
					if($val!="" && !array_key_exists($idx,$keys))
					{
						$strFields.=$idx." [old]: ";
						if(IsBinaryType($pSet->getFieldType($idx)))
							$v="<binary value>";
						else
						{
							$v = str_replace(array("\r\n","\n","\t")," ",$val);
							$v = $this->getMaxLengthSubstr( $v );
						}
						$strFields.=$v."\r\n";
					}
				}
			}
			if($strFields!="")
				$str.=$this->strFieldsHeader."\r\n".$strFields;

			$this->insert(now(), $this->params[0], $this->params[1], $str_table, $this->strDelete, $str);
		}
		return $retval;
    }

    function LogAddEvent($message,$description="",$stable="")
    {
		global $globalEvents;
		$retval=true;
		$table=$stable;
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($message, $this->params, $table, $keys, $values, $arr);
		if($retval)
		{
			$this->insert(now(), $this->params[0], $this->params[1], $stable, $message, $description);
		}
		return $retval;
    }

    function LoginSuccessful()
    {
		if($this->attLogin>0 && $this->timeLogin>0)
		{
			$where = $this->connection->addFieldWrappers("ip"). "=" .$this->connection->prepareString($_SERVER["REMOTE_ADDR"]).
				" AND " .$this->connection->addFieldWrappers("action"). "=" .$this->connection->prepareString($this->strAccess);
			$sql = "DELETE FROM " .$this->connection->addTableWrappers( $this->logTableName ). " WHERE " .$where;

			$this->connection->exec( $sql );
		}

    }

    function LoginUnsuccessful($pUsername)
    {
		if($this->attLogin>0 && $this->timeLogin>0)
		{
			$this->insert(now(), $_SERVER["REMOTE_ADDR"], $pUsername, "", $this->strAccess, "");
		}
    }

	function LoginAccess()
	{
		if( $this->attLogin > 0 && $this->timeLogin > 0 )
		{
			$where = $this->connection->addFieldWrappers("ip"). "=" .$this->connection->prepareString($_SERVER["REMOTE_ADDR"]).
				" AND " .$this->connection->addFieldWrappers("action"). "=".$this->connection->prepareString("access");
			$orderBy = $this->connection->addFieldWrappers("id")." asc";
			$sql = "SELECT * FROM " .$this->connection->addTableWrappers( $this->logTableName ). " WHERE " .$where. " ORDER BY " .$orderBy;

			$qResult = $this->connection->query( $sql );

			$i = 0;
			while( $data = $qResult->fetchAssoc() )
			{
				if( secondsPassedFrom($data["datetime"]) / 60 <= $this->timeLogin )
				{
					if($i==0)
						$firstAccess=$data["datetime"];
					$i+=1;
				}
			}

			if( $i >= $this->attLogin )
				return ceil($this->timeLogin-secondsPassedFrom($firstAccess) / 60);
		}

		return false;
	}

	function logValueEnable($table)
	{
		if($table=="leave")
		{
			return true;
		}
		if($table=="loan")
		{
			return true;
		}
		if($table=="over_time")
		{
			return true;
		}
		if($table=="change_time")
		{
			return true;
		}
		if($table=="Dashboard")
		{
			return false;
		}
		if($table=="employees")
		{
			return true;
		}
		if($table=="payroll_item")
		{
			return true;
		}
		if($table=="fieldwork")
		{
			return true;
		}
		if($table=="For_Approval_Dashboard")
		{
			return false;
		}
		if($table=="For_Checking_Dashboard")
		{
			return false;
		}
		if($table=="activity_log")
		{
			return true;
		}
		if($table=="employee_project")
		{
			return true;
		}
		if($table=="employee_project_task")
		{
			return true;
		}
		if($table=="employee_project_detail")
		{
			return true;
		}
		if($table=="Leave_for_checking")
		{
			return true;
		}
		if($table=="Leave_for_approval")
		{
			return true;
		}
		if($table=="request_for_payment")
		{
			return true;
		}
		if($table=="request_for_payment_detail")
		{
			return true;
		}
		if($table=="purchase_request")
		{
			return true;
		}
		if($table=="purchase_request_detail")
		{
			return true;
		}
		if($table=="loan__detail")
		{
			return true;
		}
		if($table=="Overtime_for_checking")
		{
			return true;
		}
		if($table=="Overtime_for_approval")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_for_approval")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_for_checking")
		{
			return true;
		}
		if($table=="payroll_account_type")
		{
			return true;
		}
		if($table=="undertime")
		{
			return true;
		}
		if($table=="Undertime_for_approval")
		{
			return true;
		}
		if($table=="Undertime_for_checking")
		{
			return true;
		}
		if($table=="credit_terms")
		{
			return true;
		}
		if($table=="currency")
		{
			return true;
		}
		if($table=="currency_exchange_rate")
		{
			return true;
		}
		if($table=="cost_center")
		{
			return true;
		}
		if($table=="location")
		{
			return true;
		}
		if($table=="phase")
		{
			return true;
		}
		if($table=="chart_of_accounts")
		{
			return true;
		}
		if($table=="item")
		{
			return true;
		}
		if($table=="uom")
		{
			return true;
		}
		if($table=="vat_type")
		{
			return true;
		}
		if($table=="vat_rate")
		{
			return true;
		}
		if($table=="request_for_payment_for_approval")
		{
			return true;
		}
		if($table=="request_for_payment_for_checking")
		{
			return true;
		}
		if($table=="request_for_payment_detail_for_approval")
		{
			return true;
		}
		if($table=="request_for_payment_detail_for_checking")
		{
			return true;
		}
		if($table=="Purchase_Request_for_approval")
		{
			return true;
		}
		if($table=="Purchase_Request_for_checking")
		{
			return true;
		}
		if($table=="purchase_request_detail_for_approval")
		{
			return true;
		}
		if($table=="purchase_request_detail_for_checking")
		{
			return true;
		}
		if($table=="payroll_system_user")
		{
			return true;
		}
		if($table=="discounts")
		{
			return true;
		}
		if($table=="sales_order")
		{
			return true;
		}
		if($table=="attendance_report_report")
		{
			return false;
		}
		if($table=="Loan_Balance")
		{
			return false;
		}
		if($table=="loan__detail_Report")
		{
			return false;
		}
		if($table=="leave_balance")
		{
			return false;
		}
		if($table=="process_payroll")
		{
			return true;
		}
		if($table=="process_payroll_detail")
		{
			return true;
		}
		if($table=="reimbursement")
		{
			return true;
		}
		if($table=="reimbursement_detail")
		{
			return true;
		}
		if($table=="serial_no")
		{
			return true;
		}
		if($table=="lot")
		{
			return true;
		}
		if($table=="tranasactions_for_approval")
		{
			return true;
		}
		if($table=="change_password")
		{
			return true;
		}
		if($table=="employee Information")
		{
			return false;
		}
		if($table=="Payroll Information")
		{
			return false;
		}
		if($table=="applicant_requirements")
		{
			return false;
		}
		if($table=="pending_requirements")
		{
			return false;
		}
		if($table=="announcements")
		{
			return false;
		}
		if($table=="employment_history")
		{
			return false;
		}
		if($table=="violations_Report")
		{
			return false;
		}
		if($table=="attendance_report_for_DSM")
		{
			return false;
		}
		if($table=="attendance_report_for_RSM")
		{
			return false;
		}
		if($table=="attendance_report_for_NSM")
		{
			return false;
		}
		if($table=="attendance_rsm")
		{
			return false;
		}
		if($table=="attendance_dsm")
		{
			return false;
		}
		if($table=="attendance_nsm")
		{
			return false;
		}
		if($table=="attendance_type")
		{
			return false;
		}
		if($table=="Fieldwork_for_checking")
		{
			return true;
		}
		if($table=="Fieldwork_for_approval")
		{
			return true;
		}
		if($table=="attendance")
		{
			return false;
		}
		if($table=="attendance_report_subordinate")
		{
			return false;
		}
		if($table=="leave_balance_subordinate")
		{
			return false;
		}
		if($table=="attendance_log_subordinate")
		{
			return false;
		}
		if($table=="employee_dependents")
		{
			return false;
		}
		if($table=="admin_rights")
		{
			return false;
		}
		if($table=="loan_for_approval")
		{
			return true;
		}
		if($table=="loan_for_checking")
		{
			return true;
		}
		if($table=="login_logout")
		{
			return false;
		}
		if($table=="attendance_report")
		{
			return false;
		}
		if($table=="attendance_subordinate")
		{
			return false;
		}
		if($table=="employee_report_center")
		{
			return false;
		}
		if($table=="attendance_subordinate_report")
		{
			return false;
		}
		if($table=="holiday_overtime")
		{
			return true;
		}
		if($table=="holiday_over_time_for_approvalx")
		{
			return true;
		}
		if($table=="holiday_over_time_for_checkingx")
		{
			return true;
		}
		if($table=="holiday")
		{
			return false;
		}
		if($table=="holiday_overtime_for_checking")
		{
			return true;
		}
		if($table=="holiday_overtime_for_approval")
		{
			return true;
		}
		if($table=="employees_subordinate")
		{
			return true;
		}
		if($table=="attendance_edit_subordinate")
		{
			return false;
		}
		if($table=="employees_schedule")
		{
			return true;
		}
		if($table=="schedule")
		{
			return false;
		}
		if($table=="admin_members")
		{
			return false;
		}
		if($table=="admin_users")
		{
			return false;
		}
		if($table=="dtr_project")
		{
			return false;
		}
		if($table=="project")
		{
			return true;
		}
		if($table=="tasks")
		{
			return false;
		}
		if($table=="dtr_project_for_approval")
		{
			return false;
		}
		if($table=="summary_hrs")
		{
			return false;
		}
		if($table=="Employee_Info")
		{
			return true;
		}
		if($table=="reimbursement_for_checking")
		{
			return true;
		}
		if($table=="reimbursement_for_approval")
		{
			return true;
		}
		if($table=="missing_logs")
		{
			return false;
		}
		if($table=="Missing_Logs_for_checking")
		{
			return false;
		}
		if($table=="Missing_Logs_for_approval")
		{
			return false;
		}
		if($table=="flexben")
		{
			return false;
		}
		if($table=="department")
		{
			return false;
		}
		if($table=="flexben_type")
		{
			return false;
		}
		if($table=="Flexben_for_checking")
		{
			return false;
		}
		if($table=="Flexben_for_approval1")
		{
			return false;
		}
		if($table=="Flexben_for_approval")
		{
			return false;
		}
		if($table=="payroll_ticketing")
		{
			return false;
		}
		if($table=="job_grade")
		{
			return false;
		}
		if($table=="level")
		{
			return false;
		}
		if($table=="Overtime_approver1")
		{
			return true;
		}
		if($table=="Overtime_approver2")
		{
			return true;
		}
		if($table=="Overtime_approver3")
		{
			return true;
		}
		if($table=="Overtime_approver4")
		{
			return true;
		}
		if($table=="Leave_approver1")
		{
			return true;
		}
		if($table=="Leave_approver2")
		{
			return true;
		}
		if($table=="Leave_approver3")
		{
			return true;
		}
		if($table=="Leave_approver4")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_approver1")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_approver2")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_approver3")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_approver4")
		{
			return true;
		}
		if($table=="Official_Business_approver1")
		{
			return true;
		}
		if($table=="Official_Business_approver2")
		{
			return true;
		}
		if($table=="Official_Business_approver3")
		{
			return true;
		}
		if($table=="Official_Business_approver4")
		{
			return true;
		}
		if($table=="Missing_Logs_approver1")
		{
			return false;
		}
		if($table=="Missing_Logs_approver2")
		{
			return false;
		}
		if($table=="Missing_Logs_approver3")
		{
			return false;
		}
		if($table=="Missing_Logs_approver4")
		{
			return false;
		}
		if($table=="Holiday_Overtime_approver1")
		{
			return true;
		}
		if($table=="Holiday_Overtime_approver2")
		{
			return true;
		}
		if($table=="Holiday_Overtime_approver3")
		{
			return true;
		}
		if($table=="Holiday_Overtime_approver4")
		{
			return true;
		}
		if($table=="year_end_pto_conversion")
		{
			return false;
		}
		if($table=="cto")
		{
			return false;
		}
		if($table=="cto_approver1")
		{
			return false;
		}
		if($table=="cto_approver2")
		{
			return false;
		}
		if($table=="cto_approver3")
		{
			return false;
		}
		if($table=="cto_approver4")
		{
			return false;
		}
		if($table=="History_Change_Time_Schedule_approver1")
		{
			return true;
		}
		if($table=="History_Change_Time_Schedule_approver2")
		{
			return true;
		}
		if($table=="History_Change_Time_Schedule_approver3")
		{
			return true;
		}
		if($table=="History_Change_Time_Schedule_approver4")
		{
			return true;
		}
		if($table=="History_cto_approver1")
		{
			return false;
		}
		if($table=="History_cto_approver2")
		{
			return false;
		}
		if($table=="History_cto_approver3")
		{
			return false;
		}
		if($table=="History_cto_approver4")
		{
			return false;
		}
		if($table=="History_Holiday_Overtime_approver1")
		{
			return true;
		}
		if($table=="History_Holiday_Overtime_approver2")
		{
			return true;
		}
		if($table=="History_Holiday_Overtime_approver3")
		{
			return true;
		}
		if($table=="History_Holiday_Overtime_approver4")
		{
			return true;
		}
		if($table=="History_Leave_approver1")
		{
			return true;
		}
		if($table=="History_Leave_approver2")
		{
			return true;
		}
		if($table=="History_Leave_approver3")
		{
			return true;
		}
		if($table=="History_Leave_approver4")
		{
			return true;
		}
		if($table=="History_Missing_Logs_approver1")
		{
			return false;
		}
		if($table=="History_Missing_Logs_approver2")
		{
			return false;
		}
		if($table=="History_Missing_Logs_approver3")
		{
			return false;
		}
		if($table=="History_Missing_Logs_approver4")
		{
			return false;
		}
		if($table=="History_Official_Business_approver1")
		{
			return true;
		}
		if($table=="History_Official_Business_approver2")
		{
			return true;
		}
		if($table=="History_Official_Business_approver3")
		{
			return true;
		}
		if($table=="History_Official_Business_approver4")
		{
			return true;
		}
		if($table=="History_Overtime_approver1")
		{
			return true;
		}
		if($table=="History_Overtime_approver2")
		{
			return true;
		}
		if($table=="History_Overtime_approver3")
		{
			return true;
		}
		if($table=="History_Overtime_approver4")
		{
			return true;
		}
		if($table=="Approval_Dashboard")
		{
			return false;
		}
		if($table=="Change_Time_Schedule_approval")
		{
			return true;
		}
		if($table=="Overtime_approval")
		{
			return true;
		}
		if($table=="Leave_approval")
		{
			return true;
		}
		if($table=="Official_Business_approval")
		{
			return true;
		}
		if($table=="Missing_Logs_approval")
		{
			return false;
		}
		if($table=="Holiday_Overtime_approval")
		{
			return true;
		}
		if($table=="CTO_approval")
		{
			return false;
		}
		if($table=="employeesdd")
		{
			return true;
		}
		if($table=="process_payroll Report")
		{
			return false;
		}
		if($table=="offsetting")
		{
			return false;
		}
		if($table=="Offsetting_approval")
		{
			return false;
		}
		if($table=="Offset_approval")
		{
			return false;
		}
	}

	protected function insert($datetime, $ip, $user, $table, $action, $description)
	{
		$sql = "INSERT INTO " .$this->connection->addTableWrappers( $this->logTableName ).
			" (" .$this->connection->addFieldWrappers("datetime").
			"," .$this->connection->addFieldWrappers("ip").
			"," .$this->connection->addFieldWrappers("user").
			"," .$this->connection->addFieldWrappers("table").
			"," .$this->connection->addFieldWrappers("action").
			"," .$this->connection->addFieldWrappers("description").
			") VALUES (" .$this->connection->addDateQuotes($datetime).
			"," .$this->connection->prepareString($ip).
			"," .$this->connection->prepareString($user).
			"," .$this->connection->prepareString($table).
			"," .$this->connection->prepareString($action).
			"," .$this->connection->prepareString($description).
			")";

		return $this->connection->exec( $sql );
	}

	protected function getMaxLengthSubstr( $value )
	{
		if( $this->maxFieldLength && strlen($value) > $this->maxFieldLength )
			return runner_substr($value, 0, $this->maxFieldLength);

		return $value;
	}
}

class AuditTrailFile
{
	var $logfile="audit.log";
	var $strLogin="login";
	var $strFailLogin="failed login";
	var $strLogout="logout";
	var $strChPass="change password";
	var $strAdd="add";
	var $strEdit="edit";
	var $strDelete="delete";
	var $strAccess="access";
	var $strKeysHeader="---Keys";
	var $strFieldsHeader="---Fields";
	var $columnDate="Date";
	var $columnTime="Time";
	var $columnIP="IP";
	var $columnUser="User";
	var $columnTable="Table";
	var $columnAction="Action";
	var $columnKey="Key field";
	var $columnField="Field";
	var $columnOldValue="Old value";
	var $columnNewValue="New value";
	var $params;
	var $maxFieldLength;

	function __construct()
	{
		global $auditMaxFieldLength;

		$userid = "";
		if(@Security::getUserName())
			$userid = Security::getUserName();

		$this->params = array($_SERVER["REMOTE_ADDR"], $userid);

		$this->maxFieldLength = $auditMaxFieldLength;
	}

    function LogLogin($pUsername)
    {
				global $globalEvents;
		$retval=true;
		$table="employees";
		$this->params[1]=$pUsername;
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strLogin, $this->params, $table, $arr, $arr, $arr);
		if($retval)
		{
			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$this->params[0].chr(9).$this->params[1].chr(9).$table.chr(9).$this->strLogin."\r\n";
			$this->writeToLogFile( $str );
		}
		return $retval;
    }

    function LogLoginFailed($pUsername)
    {
				global $globalEvents;
		$retval=true;
		$table="employees";
		$this->params[1]=$pUsername;
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strFailLogin, $this->params, $table, $arr, $arr, $arr);
		if($retval)
		{
			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$this->params[0].chr(9).$this->params[1].chr(9).$table.chr(9).$this->strFailLogin."\r\n";
			$this->writeToLogFile( $str );
		}
		return $retval;
    }

    function LogLogout()
    {
		global $globalEvents;
		if(Security::getUserName() != "" )
		{
			$retval=true;
			$table="employees";
			$arr=array();
			if($globalEvents->exists("OnAuditLog"))
				$retval=$globalEvents->OnAuditLog($this->strLogout, $this->params, $table, $arr, $arr, $arr);
			if($retval)
			{
				$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$this->params[0].chr(9).$this->params[1].chr(9).$table.chr(9).$this->strLogout."\r\n";
				$this->writeToLogFile( $str );
			}
			return $retval;
		}
    }

    function LogChPassword( $username )
    {
		global $globalEvents;
		$retval=true;
		$table="employees";
		$arr=array();
		$this->params[ 1 ] = $username;
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strChPass, $this->params, $table, $arr, $arr, $arr);
		if($retval)
		{
			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$this->params[0].chr(9).$this->params[1].chr(9).$table.chr(9).$this->strChPass."\r\n";
			$this->writeToLogFile( $str );
		}
		return $retval;
    }

    function LogAdd($str_table,$values,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strAdd, $this->params, $table, $keys, $values, $arr);
		if($retval)
		{
			if(count($keys)>0)
			{
				$key="";
				foreach($keys as $idx=>$val)
				{
					if($key!="")
						$key.=",";
					$key.=$val;
				}
			}

			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$this->params[0].chr(9).$this->params[1].chr(9).$table.chr(9).$this->strAdd.chr(9).$key;
			$str_add="";
			if($this->logValueEnable($str_table))
			{
				foreach($values as $idx=>$val)
				{
					if($val!="" && !array_key_exists($idx,$keys))
					{
						$v="";
						if(IsBinaryType($pSet->getFieldType($idx)))
							$v="<binary value>"."\r\n";
						else
						{
							$v = str_replace(array("\r\n","\n","\t")," ",$val);
							$v = $this->getMaxLengthSubstr( $v );
						}
						$str_add.=$str.chr(9).$idx.chr(9).chr(9).$v."\r\n";
					}
				}
			}
			else
				$str_add.=$str."\r\n";

			$this->writeToLogFile( $str_add );
		}
		return $retval;
    }

    function LogEdit($str_table,$newvalues,$oldvalues,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strEdit, $this->params, $table, $keys, $newvalues, $oldvalues);
		if($retval)
		{
			if(count($keys)>0)
			{
				$key="";
				foreach($keys as $idx=>$val)
				{
					if($key!="")
						$key.=",";
					$key.=$val;
				}
			}

			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$this->params[0].chr(9).$this->params[1].chr(9).$table.chr(9).$this->strEdit.chr(9).$key;
			$putsValue=true;
			$str_add="";
			if($this->logValueEnable($str_table))
			{
				foreach($newvalues as $idx=>$val)
				{
					$type=$pSet->getFieldType($idx);
					if(IsBinaryType($type))
						continue;
					if(IsDateFieldType($type))
					{
						$newvalue=format_datetime_custom(db2time($newvalues[$idx]),"yyyy-MM-dd HH:mm:ss");
						$oldvalue=format_datetime_custom(db2time($oldvalues[$idx]),"yyyy-MM-dd HH:mm:ss");
					}
					else
					{
						$newvalue=$newvalues[$idx];
						$oldvalue=$oldvalues[$idx];
					}
					if($newvalue!=$oldvalue)
					{
						$v1="";
						if(IsBinaryType($type))
							$v1="<binary value>";
						else
						{
							$v1 = str_replace(array("\r\n","\n","\t")," ",$oldvalue);
							$v = $this->getMaxLengthSubstr( $v );
						}

						$v2="";
						if(IsBinaryType($type))
							$v2="<binary value>";
						else
						{
							$v2 = str_replace(array("\r\n","\n","\t")," ",$newvalue);
							$v2 = $this->getMaxLengthSubstr( $v2 );
						}
						$str_add.=$str.chr(9).$idx.chr(9).$v1.chr(9).$v2."\r\n";
					}
				}
			}
			else
				$str_add.=$str."\r\n";
			$this->writeToLogFile( $str_add );
		}
		return $retval;
    }

    function LogDelete($str_table,$values,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strDelete, $this->params, $table, $keys, $values, $arr);
		if($retval)
		{
			if(count($keys)>0)
			{
				$key="";
				foreach($keys as $idx=>$val)
				{
					if($key!="")
						$key.=",";
					$key.=$val;
				}
			}
			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$this->params[0].chr(9).$this->params[1].chr(9).$table.chr(9).$this->strDelete.chr(9).$key;
			$str_add="";
			if($this->logValueEnable($str_table))
			{
				foreach($values as $idx=>$val)
				{
					$v="";
					if(IsBinaryType($pSet->getFieldType($idx)))
						$v="<binary value>";
					else
					{
						$v = str_replace(array("\r\n","\n","\t")," ",$val);
						$v = $this->getMaxLengthSubstr( $v );
					}
					$str_add.=$str.chr(9).$idx.chr(9).$v."\r\n";
				}
			}
			else
				$str_add=$str."\r\n";

			$this->writeToLogFile( $str_add );
		}
		return $retval;
    }

	function writeToLogFile( $str )
	{
		$p=strrpos($this->logfile,".");
		$logfileName=runner_substr($this->logfile,0,$p);
		$logfileExt=runner_substr($this->logfile,$p+1, strlen($this->logfile)-1);
		$tn=$logfileName."_".format_datetime_custom(db2time(now()),"yyyyMMdd").".".$logfileExt;

		$fullname = getabspath($tn);
		$fsize = 0;
		if (file_exists($fullname)){
			$fsize = filesize($fullname);
		}
		$str_to_append = "";
		if( !$fsize )
		{
			$str_to_append = $this->columnDate.chr(9).$this->columnTime.chr(9).$this->columnIP.chr(9).$this->columnUser.chr(9).$this->columnTable.chr(9).$this->columnAction.chr(9).$this->columnKey.chr(9).$this->columnField.chr(9).$this->columnOldValue.chr(9).$this->columnNewValue."\r\n";
		}
		$str_to_append .= $str;
		append_to_file( $fullname, $str_to_append );

	}

	function LogAddEvent($message,$description="",$str_table="")
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($message, $this->params, $table, $arr, $arr, $arr);
		if($retval)
		{
			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$params[0].chr(9).$params[1].chr(9).$table.chr(9).$message.chr(9).$description."\r\n";
			$this->writeToLogFile( $str );
		}
		return $retval;
    }

    function LoginAccess()
	{
		return false;
	}

	function LoginSuccessful()
    {
		return true;
    }

    function LoginUnsuccessful($pUsername)
    {
		return true;
	}

	function logValueEnable($table)
	{
		if($table=="leave")
		{
			return true;
		}
		if($table=="loan")
		{
			return true;
		}
		if($table=="over_time")
		{
			return true;
		}
		if($table=="change_time")
		{
			return true;
		}
		if($table=="Dashboard")
		{
			return false;
		}
		if($table=="employees")
		{
			return true;
		}
		if($table=="payroll_item")
		{
			return true;
		}
		if($table=="fieldwork")
		{
			return true;
		}
		if($table=="For_Approval_Dashboard")
		{
			return false;
		}
		if($table=="For_Checking_Dashboard")
		{
			return false;
		}
		if($table=="activity_log")
		{
			return true;
		}
		if($table=="employee_project")
		{
			return true;
		}
		if($table=="employee_project_task")
		{
			return true;
		}
		if($table=="employee_project_detail")
		{
			return true;
		}
		if($table=="Leave_for_checking")
		{
			return true;
		}
		if($table=="Leave_for_approval")
		{
			return true;
		}
		if($table=="request_for_payment")
		{
			return true;
		}
		if($table=="request_for_payment_detail")
		{
			return true;
		}
		if($table=="purchase_request")
		{
			return true;
		}
		if($table=="purchase_request_detail")
		{
			return true;
		}
		if($table=="loan__detail")
		{
			return true;
		}
		if($table=="Overtime_for_checking")
		{
			return true;
		}
		if($table=="Overtime_for_approval")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_for_approval")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_for_checking")
		{
			return true;
		}
		if($table=="payroll_account_type")
		{
			return true;
		}
		if($table=="undertime")
		{
			return true;
		}
		if($table=="Undertime_for_approval")
		{
			return true;
		}
		if($table=="Undertime_for_checking")
		{
			return true;
		}
		if($table=="credit_terms")
		{
			return true;
		}
		if($table=="currency")
		{
			return true;
		}
		if($table=="currency_exchange_rate")
		{
			return true;
		}
		if($table=="cost_center")
		{
			return true;
		}
		if($table=="location")
		{
			return true;
		}
		if($table=="phase")
		{
			return true;
		}
		if($table=="chart_of_accounts")
		{
			return true;
		}
		if($table=="item")
		{
			return true;
		}
		if($table=="uom")
		{
			return true;
		}
		if($table=="vat_type")
		{
			return true;
		}
		if($table=="vat_rate")
		{
			return true;
		}
		if($table=="request_for_payment_for_approval")
		{
			return true;
		}
		if($table=="request_for_payment_for_checking")
		{
			return true;
		}
		if($table=="request_for_payment_detail_for_approval")
		{
			return true;
		}
		if($table=="request_for_payment_detail_for_checking")
		{
			return true;
		}
		if($table=="Purchase_Request_for_approval")
		{
			return true;
		}
		if($table=="Purchase_Request_for_checking")
		{
			return true;
		}
		if($table=="purchase_request_detail_for_approval")
		{
			return true;
		}
		if($table=="purchase_request_detail_for_checking")
		{
			return true;
		}
		if($table=="payroll_system_user")
		{
			return true;
		}
		if($table=="discounts")
		{
			return true;
		}
		if($table=="sales_order")
		{
			return true;
		}
		if($table=="attendance_report_report")
		{
			return false;
		}
		if($table=="Loan_Balance")
		{
			return false;
		}
		if($table=="loan__detail_Report")
		{
			return false;
		}
		if($table=="leave_balance")
		{
			return false;
		}
		if($table=="process_payroll")
		{
			return true;
		}
		if($table=="process_payroll_detail")
		{
			return true;
		}
		if($table=="reimbursement")
		{
			return true;
		}
		if($table=="reimbursement_detail")
		{
			return true;
		}
		if($table=="serial_no")
		{
			return true;
		}
		if($table=="lot")
		{
			return true;
		}
		if($table=="tranasactions_for_approval")
		{
			return true;
		}
		if($table=="change_password")
		{
			return true;
		}
		if($table=="employee Information")
		{
			return false;
		}
		if($table=="Payroll Information")
		{
			return false;
		}
		if($table=="applicant_requirements")
		{
			return false;
		}
		if($table=="pending_requirements")
		{
			return false;
		}
		if($table=="announcements")
		{
			return false;
		}
		if($table=="employment_history")
		{
			return false;
		}
		if($table=="violations_Report")
		{
			return false;
		}
		if($table=="attendance_report_for_DSM")
		{
			return false;
		}
		if($table=="attendance_report_for_RSM")
		{
			return false;
		}
		if($table=="attendance_report_for_NSM")
		{
			return false;
		}
		if($table=="attendance_rsm")
		{
			return false;
		}
		if($table=="attendance_dsm")
		{
			return false;
		}
		if($table=="attendance_nsm")
		{
			return false;
		}
		if($table=="attendance_type")
		{
			return false;
		}
		if($table=="Fieldwork_for_checking")
		{
			return true;
		}
		if($table=="Fieldwork_for_approval")
		{
			return true;
		}
		if($table=="attendance")
		{
			return false;
		}
		if($table=="attendance_report_subordinate")
		{
			return false;
		}
		if($table=="leave_balance_subordinate")
		{
			return false;
		}
		if($table=="attendance_log_subordinate")
		{
			return false;
		}
		if($table=="employee_dependents")
		{
			return false;
		}
		if($table=="admin_rights")
		{
			return false;
		}
		if($table=="loan_for_approval")
		{
			return true;
		}
		if($table=="loan_for_checking")
		{
			return true;
		}
		if($table=="login_logout")
		{
			return false;
		}
		if($table=="attendance_report")
		{
			return false;
		}
		if($table=="attendance_subordinate")
		{
			return false;
		}
		if($table=="employee_report_center")
		{
			return false;
		}
		if($table=="attendance_subordinate_report")
		{
			return false;
		}
		if($table=="holiday_overtime")
		{
			return true;
		}
		if($table=="holiday_over_time_for_approvalx")
		{
			return true;
		}
		if($table=="holiday_over_time_for_checkingx")
		{
			return true;
		}
		if($table=="holiday")
		{
			return false;
		}
		if($table=="holiday_overtime_for_checking")
		{
			return true;
		}
		if($table=="holiday_overtime_for_approval")
		{
			return true;
		}
		if($table=="employees_subordinate")
		{
			return true;
		}
		if($table=="attendance_edit_subordinate")
		{
			return false;
		}
		if($table=="employees_schedule")
		{
			return true;
		}
		if($table=="schedule")
		{
			return false;
		}
		if($table=="admin_members")
		{
			return false;
		}
		if($table=="admin_users")
		{
			return false;
		}
		if($table=="dtr_project")
		{
			return false;
		}
		if($table=="project")
		{
			return true;
		}
		if($table=="tasks")
		{
			return false;
		}
		if($table=="dtr_project_for_approval")
		{
			return false;
		}
		if($table=="summary_hrs")
		{
			return false;
		}
		if($table=="Employee_Info")
		{
			return true;
		}
		if($table=="reimbursement_for_checking")
		{
			return true;
		}
		if($table=="reimbursement_for_approval")
		{
			return true;
		}
		if($table=="missing_logs")
		{
			return false;
		}
		if($table=="Missing_Logs_for_checking")
		{
			return false;
		}
		if($table=="Missing_Logs_for_approval")
		{
			return false;
		}
		if($table=="flexben")
		{
			return false;
		}
		if($table=="department")
		{
			return false;
		}
		if($table=="flexben_type")
		{
			return false;
		}
		if($table=="Flexben_for_checking")
		{
			return false;
		}
		if($table=="Flexben_for_approval1")
		{
			return false;
		}
		if($table=="Flexben_for_approval")
		{
			return false;
		}
		if($table=="payroll_ticketing")
		{
			return false;
		}
		if($table=="job_grade")
		{
			return false;
		}
		if($table=="level")
		{
			return false;
		}
		if($table=="Overtime_approver1")
		{
			return true;
		}
		if($table=="Overtime_approver2")
		{
			return true;
		}
		if($table=="Overtime_approver3")
		{
			return true;
		}
		if($table=="Overtime_approver4")
		{
			return true;
		}
		if($table=="Leave_approver1")
		{
			return true;
		}
		if($table=="Leave_approver2")
		{
			return true;
		}
		if($table=="Leave_approver3")
		{
			return true;
		}
		if($table=="Leave_approver4")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_approver1")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_approver2")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_approver3")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_approver4")
		{
			return true;
		}
		if($table=="Official_Business_approver1")
		{
			return true;
		}
		if($table=="Official_Business_approver2")
		{
			return true;
		}
		if($table=="Official_Business_approver3")
		{
			return true;
		}
		if($table=="Official_Business_approver4")
		{
			return true;
		}
		if($table=="Missing_Logs_approver1")
		{
			return false;
		}
		if($table=="Missing_Logs_approver2")
		{
			return false;
		}
		if($table=="Missing_Logs_approver3")
		{
			return false;
		}
		if($table=="Missing_Logs_approver4")
		{
			return false;
		}
		if($table=="Holiday_Overtime_approver1")
		{
			return true;
		}
		if($table=="Holiday_Overtime_approver2")
		{
			return true;
		}
		if($table=="Holiday_Overtime_approver3")
		{
			return true;
		}
		if($table=="Holiday_Overtime_approver4")
		{
			return true;
		}
		if($table=="year_end_pto_conversion")
		{
			return false;
		}
		if($table=="cto")
		{
			return false;
		}
		if($table=="cto_approver1")
		{
			return false;
		}
		if($table=="cto_approver2")
		{
			return false;
		}
		if($table=="cto_approver3")
		{
			return false;
		}
		if($table=="cto_approver4")
		{
			return false;
		}
		if($table=="History_Change_Time_Schedule_approver1")
		{
			return true;
		}
		if($table=="History_Change_Time_Schedule_approver2")
		{
			return true;
		}
		if($table=="History_Change_Time_Schedule_approver3")
		{
			return true;
		}
		if($table=="History_Change_Time_Schedule_approver4")
		{
			return true;
		}
		if($table=="History_cto_approver1")
		{
			return false;
		}
		if($table=="History_cto_approver2")
		{
			return false;
		}
		if($table=="History_cto_approver3")
		{
			return false;
		}
		if($table=="History_cto_approver4")
		{
			return false;
		}
		if($table=="History_Holiday_Overtime_approver1")
		{
			return true;
		}
		if($table=="History_Holiday_Overtime_approver2")
		{
			return true;
		}
		if($table=="History_Holiday_Overtime_approver3")
		{
			return true;
		}
		if($table=="History_Holiday_Overtime_approver4")
		{
			return true;
		}
		if($table=="History_Leave_approver1")
		{
			return true;
		}
		if($table=="History_Leave_approver2")
		{
			return true;
		}
		if($table=="History_Leave_approver3")
		{
			return true;
		}
		if($table=="History_Leave_approver4")
		{
			return true;
		}
		if($table=="History_Missing_Logs_approver1")
		{
			return false;
		}
		if($table=="History_Missing_Logs_approver2")
		{
			return false;
		}
		if($table=="History_Missing_Logs_approver3")
		{
			return false;
		}
		if($table=="History_Missing_Logs_approver4")
		{
			return false;
		}
		if($table=="History_Official_Business_approver1")
		{
			return true;
		}
		if($table=="History_Official_Business_approver2")
		{
			return true;
		}
		if($table=="History_Official_Business_approver3")
		{
			return true;
		}
		if($table=="History_Official_Business_approver4")
		{
			return true;
		}
		if($table=="History_Overtime_approver1")
		{
			return true;
		}
		if($table=="History_Overtime_approver2")
		{
			return true;
		}
		if($table=="History_Overtime_approver3")
		{
			return true;
		}
		if($table=="History_Overtime_approver4")
		{
			return true;
		}
		if($table=="Approval_Dashboard")
		{
			return false;
		}
		if($table=="Change_Time_Schedule_approval")
		{
			return true;
		}
		if($table=="Overtime_approval")
		{
			return true;
		}
		if($table=="Leave_approval")
		{
			return true;
		}
		if($table=="Official_Business_approval")
		{
			return true;
		}
		if($table=="Missing_Logs_approval")
		{
			return false;
		}
		if($table=="Holiday_Overtime_approval")
		{
			return true;
		}
		if($table=="CTO_approval")
		{
			return false;
		}
		if($table=="employeesdd")
		{
			return true;
		}
		if($table=="process_payroll Report")
		{
			return false;
		}
		if($table=="offsetting")
		{
			return false;
		}
		if($table=="Offsetting_approval")
		{
			return false;
		}
		if($table=="Offset_approval")
		{
			return false;
		}
	}

	protected function getMaxLengthSubstr( $value )
	{
		if( $this->maxFieldLength && strlen($value) > $this->maxFieldLength )
			return runner_substr($value, 0, $this->maxFieldLength);

		return $value;
	}
}
?>